ToDoApp.PL.WebPL/Models/ToDoTask/CreateToDoTaskVM.cs
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace ToDoApp.PL.WebPL.Models.ToDoTaskVM
{
    public class CreateToDoTaskVM
    {
        [Required]
        [StringLength(100)]
        public string Title { get; set; } = null!;

        [UIHint("date")]
        [DisplayName("Goal date")]
        public DateTime? DueDate { get; set; }

        [DisplayName("Reminder")]
        public DateTime? TaskReminderDateTime { get; set; }
    }
}

ToDoApp.PL.WebPL/Models/ToDoTask/DisplayToDoTaskVM.cs
using System.ComponentModel;

namespace ToDoApp.PL.WebPL.Models.ToDoTaskVM
{
    public class DisplayToDoTaskVM
    {
        public Guid Id { get; set; }

        public string Title { get; set; }

        [DisplayName("Goal date")]
        public DateTime? DueDate { get; set; }

        [DisplayName("Important")]
        public bool IsImportant { get; set; }

        [DisplayName("Completed")]
        public bool IsCompleted { get; set; } = false;

        [DisplayName("Reminder")]
        public DateTime? TaskReminderDateTime { get; set; }
    }
}

ToDoApp.PL.WebPL/Models/ToDoTask/DisplayTodayToDoTaskVM.cs
namespace ToDoApp.PL.WebPL.Models.ToDoTaskVM
{
    public class DisplayTodayToDoTaskVM
    {
        public string Title { get; set; } = null!;
        
        public string ListName { get; set; } = null!;

        public Guid Id { get; set; }

        public Guid ListId { get; set; }

        public DateTime DueDate { get; set; }

        public DateTime? Reminder { get; set; }
    }
}

ToDoApp.PL.WebPL/Models/ToDoTask/ToDoTaskDetailsVM.cs
using System.ComponentModel;
using ToDoApp.Entities;

namespace ToDoApp.PL.WebPL.Models.ToDoTaskVM
{
    public class ToDoTaskDetailsVM
    {
        public string Title { get; set; } = null!;

        [DisplayName("Goal date")]
        public DateTime? DueDate { get; set; }

        public IEnumerable<ToDoTaskStep>? steps { get; set; }
    }
}

ToDoApp.PL.WebPL/Controllers/ToDoTaskController.cs
using Microsoft.AspNetCore.Mvc;
using AutoMapper;
using ToDoApp.BLL.Interfaces;
using ToDoApp.PL.WebPL.Models.ToDoTaskVM;
using ToDoApp.Entities;
using ToDoApp.PL.WebPL.Models.ToDoList;
using System.Collections.Generic;
using ToDoApp.PL.WebPL.Models;

namespace ToDoApp.PL.WebPL.Controllers
{
    public class ToDoTaskController : Controller
    {
        private readonly IMapper _mapper;

        public ToDoTaskController(IMapper mapper)
        {
            _mapper = mapper;
        }

        [HttpGet]
        public async Task<IActionResult> Index([FromRoute] Guid id,
            [FromServices] IToDoListLogic listLogic,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            var list = await listLogic.GetByIdAsync(id);
            ViewData["list"] = list.Name;
            ViewBag.ListId = id;

            var lists = await listLogic.GetAllAsync();
            var listsVM = _mapper.Map<IEnumerable<DisplayToDoListVM>>(lists);

            ViewData["listsVM"] = listsVM;
            var tasks = await taskLogic.GetAllAsync(id);

            var tasksVM = _mapper.Map<IEnumerable<DisplayToDoTaskVM>>(tasks);

            return View(tasksVM);
        }

        [HttpPost]
        public async Task<IActionResult> Create([FromRoute] Guid id,
            [FromForm] CreateToDoTaskVM taskVM,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            if (taskVM.DueDate != null && (taskVM.DueDate.Value.Date < DateTime.Now.Date
                || taskVM.DueDate.Value.Date > DateTime.Now.Date.AddYears(5)))
            {
                ModelState.AddModelError("DueDate", $"Due should be between {DateTime.Now.Date} " +
                    $"and {DateTime.Now.AddYears(5).Date}");
            }

            if (!ModelState.IsValid)
            {
                ViewBag.taskVM = taskVM;
                return RedirectToAction("Index", "ToDoTask", new { id });
            }

            var task = _mapper.Map<ToDoTask>(taskVM);
            await taskLogic.AddAsync(id, task);

            return RedirectToAction("Index", "ToDoTask", new { id });
        }

        [HttpGet("{controller}/{action}/{id}")]
        public async Task<IActionResult> Details([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic,
            [FromServices] IToDoTaskStepLogic stepLogic)
        {
            var task = await taskLogic.GetByIdAsync(id);
            var taskDetailsVM = _mapper.Map<ToDoTaskDetailsVM>(task);
            taskDetailsVM.steps = await stepLogic.GetAllAsync(id);
            var listId = task.ToDoListId;

            var tasks = await taskLogic.GetAllAsync(listId);
            var tasksVM = _mapper.Map<IEnumerable<DisplayToDoTaskVM>>(tasks);

            ViewData["tasksVM"] = tasksVM;
            ViewBag.TaskId = id;
            ViewBag.ListId = listId;
            return View(taskDetailsVM);
        }

        public async Task<IActionResult> Delete(Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            var task = await taskLogic.GetByIdAsync(id);
            Guid listId = task.ToDoListId;
            await taskLogic.DeleteAsync(id);
            return RedirectToAction("Index", "ToDoTask", new {id = listId });
        }

        [HttpGet]
        public async Task<IActionResult> EditGoalDate([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            var task = await taskLogic.GetByIdAsync(id);
            DateTime? date = task.DueDate;
            return View(date);
        }

        [HttpPost]
        public async Task<IActionResult> EditGoalDate([FromRoute] Guid id,
            [FromForm] DateTime? taskGoalDate,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            if (taskGoalDate != null && (taskGoalDate.Value.Date < DateTime.Now.Date
                || taskGoalDate.Value.Date > DateTime.Now.Date.AddYears(5)))
            {
                ModelState.AddModelError("DueDate", $"Due date should be between {DateTime.Now.Date} " +
                    $"and {DateTime.Now.AddYears(5).Date}");
            }

            if (!ModelState.IsValid)
            {
                return View(taskGoalDate);
            }

            await taskLogic.UpdateDueDateAsync(id, taskGoalDate);

            Guid listId = (await taskLogic.GetByIdAsync(id)).ToDoListId;
            return RedirectToAction("Index", "ToDoTask", new {id = listId});
        }

        [HttpGet]
        public async Task<IActionResult> EditReminder([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            var task = await taskLogic.GetByIdAsync(id);
            DateTime? date = task.TaskReminderDateTime;
            return View(date);
        }

        [HttpPost]
        public async Task<IActionResult> EditReminder([FromRoute] Guid id,
            [FromForm] DateTime? reminder,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            if (reminder != null && (reminder.Value.Date < DateTime.Now.Date
                || reminder.Value.Date > DateTime.Now.Date.AddYears(5)))
            {
                ModelState.AddModelError("Reminder", $"Reminder date should be between {DateTime.Now.Date} " +
                    $"and {DateTime.Now.AddYears(5).Date}");
            }

            if (!ModelState.IsValid)
            {
                return View(reminder);
            }

            await taskLogic.UpdateReminderAsync(id, reminder);

            Guid listId = (await taskLogic.GetByIdAsync(id)).ToDoListId;
            return RedirectToAction("Index", "ToDoTask", new { id = listId });
        }

        [HttpPost]
        public async Task<IActionResult> MarkCompleted([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            await taskLogic.ChangeCompletedStatusAsync(id);

            Guid listId = (await taskLogic.GetByIdAsync(id)).ToDoListId;
            return RedirectToAction("Index", "ToDoTask", new { id = listId });
        }

        [HttpPost]
        public async Task<IActionResult> MarkImportant([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            await taskLogic.ChangeImportantStatusAsync(id);

            Guid listId = (await taskLogic.GetByIdAsync(id)).ToDoListId;
            return RedirectToAction("Index", "ToDoTask", new { id = listId });
        }

        [HttpGet]
        public async Task<IActionResult> EditTitle([FromRoute] Guid id,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            var task = await taskLogic.GetByIdAsync(id);
            EditNameVM VM = new EditNameVM { id = id, Title = task.Title };
            return View(VM);
        }

        [HttpPost]
        public async Task<IActionResult> EditTitle([FromRoute] Guid id,
            [FromForm] EditNameVM vm,
            [FromServices] IToDoTaskLogic taskLogic)
        {
            if (string.IsNullOrEmpty(vm.Title))
            {
                ModelState.AddModelError("Title", $"Title should not be empty");
            }

            if (!ModelState.IsValid)
            {
                return View(vm);
            }

            await taskLogic.UpdateTitleAsync(id, vm.Title);

            Guid listId = (await taskLogic.GetByIdAsync(id)).ToDoListId;
            return RedirectToAction("Index", "ToDoTask", new { id = listId });
        }
    }
}

ToDoApp.PL.WebPL/Controllers/ToDoTaskStepController.cs
using Microsoft.AspNetCore.Mvc;
using ToDoApp.BLL.Interfaces;
using ToDoApp.PL.WebPL.Models;

namespace ToDoApp.PL.WebPL.Controllers
{
    public class ToDoTaskStepController : Controller
    {
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([FromRoute] Guid id,
            [FromForm] string desc,
            [FromServices] IToDoTaskStepLogic stepLogic)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Details", "ToDoTask", new { id });
            }

            await stepLogic.AddAsync(id, desc);

            return RedirectToAction("Details", "ToDoTask", new { id });
        }

        [HttpGet("{controller}/{action}/{id}/{taskId}")]
        public async Task<IActionResult> Delete(Guid id, Guid taskId,
           [FromServices] IToDoTaskStepLogic stepLogic,
           [FromServices] IToDoTaskLogic taskLogic)
        {
            await stepLogic.DeleteAsync(taskId, id);

            return RedirectToAction("Details", "ToDoTask", new { id = taskId });
        }

        [HttpGet("{controller}/{action}/{id}/{taskId}")]
        public async Task<IActionResult> Edit([FromRoute]Guid id, 
            [FromRoute] Guid taskId,
            [FromServices] IToDoTaskStepLogic stepLogic)
        {
            var step = await stepLogic.GetByIdAsync(id);
            EditNameVM VM = new EditNameVM { id = id, Title = step.Description };

            ViewBag.TaskId = taskId;
            return View(VM);
        }

        [HttpPost("{controller}/{action}/{id}/{taskId}")]
        public async Task<IActionResult> Edit([FromRoute] Guid id,
            [FromRoute] Guid taskId,
            [FromForm] string desc,
            [FromServices] IToDoTaskStepLogic stepLogic)
        {
            await stepLogic.UpdateDescAsync(id, desc);

            return RedirectToAction("Details", "ToDoTask", new {id = taskId });
        }

        [HttpPost("{controller}/{action}/{id}/{taskId}")]
        public async Task<IActionResult> MarkCompleted([FromRoute] Guid id,
            [FromRoute] Guid taskId,
            [FromServices] IToDoTaskStepLogic stepLogic)
        {
            await stepLogic.ChangeCompletedStatusAsync(id);

            return RedirectToAction("Details", "ToDoTask", new { id = taskId });
        }
    }
}

ToDoApp.PL.WebPL/ViewComponents/CreateStepViewComponent.cs
using Microsoft.AspNetCore.Mvc;

namespace ToDoApp.PL.WebPL.ViewComponents
{
    public class CreateStepViewComponent : ViewComponent
    {
        public IViewComponentResult Invoke()
        {
            return View();
        }
    }
}

ToDoApp.PL.WebPL/ViewComponents/CreateTaskViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using ToDoApp.PL.WebPL.Models.ToDoTaskVM;

namespace ToDoApp.PL.WebPL.ViewComponents
{
    public class CreateTaskViewComponent : ViewComponent
    {
        public IViewComponentResult Invoke(CreateToDoTaskVM? vm)
        {
            if(vm == null)
            {
                vm = new CreateToDoTaskVM();
            }
            return View(vm);
        }
    }
}

ToDoApp.PL.WebPL/Views/ToDoTask/Details.cshtml
@model ToDoTaskDetailsVM

@{
    Layout = "_LayoutTasks";
    ViewData["Title"] = Model.Title + " steps";
}

<div class="open-list">
    <h4 class="task-title ml-100 mt-20">@Model.Title</h4>
    <div class="block-info mt-20">
        <div class="block-tasks ml-100">
            @if (Model.steps != null && Model.steps.Any()) 
            {
                @foreach (var step in Model.steps.Where(s=>s.IsCompleted == false))
                {
                    <div class="task-item">
                        <div class="task-top-info">
                            <h4>@step.Description</h4>
                            <div class="step-icons complited">
                                <form class="btn-method" method="post" asp-controller="ToDoTaskStep" asp-action="MarkCompleted" asp-route-id="@step.Id" asp-route-taskId="@ViewBag.TaskId">
                                    <button class="btn inform" type="submit">
                                        <i class="fa fa-check-circle-o"></i>
                                    </button>
                                </form>
                            </div>
                        </div>
                        <div class="btn-div">
                            <a class="btn primary w-6-12" asp-controller="ToDoTaskStep" asp-action="Edit" asp-route-id="@step.Id" asp-route-taskId="@ViewBag.TaskId">Rename</a>
                            <a class="btn danger w-6-12" asp-controller="ToDoTaskStep" asp-action="Delete" asp-route-id="@step.Id" asp-route-taskId="@ViewBag.TaskId">Delete</a>
                        </div>   
                    </div>
                }
                if (Model.steps.Where(s => s.IsCompleted == true).Any())
                {
                    <h3 style="margin-left: 22px; font-size: 24px; color:crimson">Complited</h3>
                    @foreach (var step in Model.steps.Where(s => s.IsCompleted == true))
                    {
                        <div class="task-item">
                            <div class="task-top-info">
                                <h4>@step.Description</h4>
                                <div class="step-icons complited">
                                    <form class="btn-method" method="post" asp-controller="ToDoTaskStep" asp-action="MarkCompleted" asp-route-id="@step.Id" asp-route-taskId="@ViewBag.TaskId">
                                        <button class="btn inform" type="submit">
                                            <i class="fa fa-check-circle"></i>
                                        </button>
                                    </form>
                                </div>
                            </div>
                            <div class="btn-div">
                                <a class="btn danger w-6-12" asp-controller="ToDoTaskStep" asp-action="Delete" asp-route-id="@step.Id" asp-route-taskId="@ViewBag.TaskId">Delete</a>
                            </div>   
                        </div>
                    }

                }
            }
            else
            {
                <h3 style="margin-left: 22px; font-size: 24px; color:crimson">Nothing here yet...</h3>
            }
        </div>
        @await Component.InvokeAsync("CreateStep")
    </div>
</div>

ToDoApp.PL.WebPL/Views/ToDoTask/EditGoalDate.cshtml
@model DateTime?
@{
    ViewData["Title"] = "Change Goal Date";
    Layout = "_LayoutEdit";
}

<form asp-controller="ToDoTask" asp-action="EditGoalDate" class="form-update">
    <h3>New due date</h3>
    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
    @if (Model.HasValue)
    {
        <input name="taskGoalDate" type="date" class="input-border w-full" value="@Model.Value">
    }
    else
    {
        <input name="taskGoalDate" type="date" class="input-border w-full">
    }
    <button type="submit" class="btn primary w-full">Change</button>
</form>

ToDoApp.PL.WebPL/Views/ToDoTask/EditReminder.cshtml
@model DateTime?
@{
    ViewData["Title"] = "Change reminder";
    Layout = "_LayoutEdit";
}

<form asp-controller="ToDoTask" asp-action="EditReminder" class="form-update">
    <h3>Set new reminder</h3>
    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
    @if (Model.HasValue)
    {
        <input name="reminder" type="datetime" class="input-border w-full" value="@Model">
    }
    else
    {
        <input name="reminder" type="datetime" class="input-border w-full">
    }
    <button type="submit" class="btn primary w-full">Set</button>
</form>

ToDoApp.PL.WebPL/Views/ToDoTask/EditTitle.cshtml
@model EditNameVM

@{
    Layout = "_LayoutEdit";
    ViewData["Title"] = "Change title";
}

<form asp-controller="ToDoTask" asp-action="EditTitle" asp-route-id="@Model.id" class="form-update">
    <h3>Change title</h3>
    <input type="text" asp-for="Title" class="input-border w-full">
    <button type="submit" class="btn primary w-full">Rename</button>
</form>

ToDoApp.PL.WebPL/Views/ToDoTask/Index.cshtml
@model IEnumerable<DisplayToDoTaskVM>

@{
    Layout = "_LayoutLists";
    ViewData["Title"] = ViewData["list"] + " tasks";
}

<div class="open-list">
    <h4 class="task-title ml-100 mt-20">@ViewData["list"]</h4>
    <div class="block-info mt-20">
        <div class="block-tasks ml-100">
            @foreach(var task in Model.Where(t=>t.IsCompleted == false))
            {
            <div class="task-item">
                <div class="task-top-info">
                    <a asp-controller="ToDoTask" asp-action="Details" asp-route-id="@task.Id" asp-route-listId="@ViewBag.ListId" class="link">
                        <h4>@task.Title</h4>
                    </a>
                    <div class="task-icons">
                        <form class="btn-method" asp-controller="ToDoTask" asp-action="MarkCompleted" asp-route-id="@task.Id" method="post">
                            <button type="submit" class="btn inform">
                                <i class="fa fa-check-circle-o"></i>
                            </button>
                        </form>
                        <form class="btn-method" asp-controller="ToDoTask" asp-action="MarkImportant" asp-route-id="@task.Id" method="post">
                            <button type="submit" class="btn inform">
                                    @if (task.IsImportant)
                                    {
                                        <i class="fa fa-star"></i>
                                    }
                                    else
                                    {
                                        <i class="fa fa-star-o"></i>
                                    }
                                </button>
                        </form>
                        <a asp-controller="ToDoTask" asp-action="EditGoalDate" asp-route-id="@task.Id" class="btn inform">
                            <i class="fa fa-calendar-o"></i>
                        </a>
                        <a asp-controller="ToDoTask" asp-action="EditReminder" asp-route-id="@task.Id" class="btn inform">
                            <i class="fa fa-clock-o"></i>
                        </a>
                    </div>
                </div>
                <div class="task-bottom-info">
                    @if(task.DueDate.HasValue)
                    {
                        <p class="date-text">Goal Date: @task.DueDate.Value.ToString("d")</p>
                    }
                    else
                    {
                        <p class="date-text">Goal Date: not set</p>    
                    }
                    @if(task.TaskReminderDateTime.HasValue)
                    {
                        <p class="date-text">Reminder Date: @task.TaskReminderDateTime.Value.ToString("g")</p>
                    }
                    else
                    {
                        <p class="date-text">Reminder Date: not set</p>    
                    }
                </div> 
                <div class="btn-div">
                    <a class="btn primary w-6-12" asp-controller="ToDoTask" asp-action="EditTitle" asp-route-id="@task.Id">Rename</a>
                    <a class="btn danger w-6-12" asp-controller="ToDoTask" asp-action="Delete" asp-route-id="@task.Id">Delete</a>
                </div>   
            </div>
            }
            @if (Model.Where(s => s.IsCompleted == true).Any())
            {
                <h3 style="margin-left: 22px; font-size: 24px; color:crimson">Complited</h3>
                @foreach (var task in Model.Where(t => t.IsCompleted == true))
                {
                    <div class="task-item">
                        <div class="task-top-info">
                            <h4>@task.Title</h4>
                            <div class="task-icons complited">
                                <form asp-controller="ToDoTask" asp-action="MarkCompleted" asp-route-id="@task.Id" method="post">
                                    <button type="submit" class="btn inform">
                                        <i class="fa fa-check-circle"></i>
                                    </button>
                                </form>
                            </div>
                        </div>
                        <div class="btn-div">
                            <a class="btn danger w-6-12" asp-controller="ToDoTask" asp-action="Delete" asp-route-id="@task.Id">Delete</a>
                        </div> 
                    </div>
                }
            }
            @if(!Model.Any())
            {
                <h3 style="margin-left: 22px; font-size: 24px; color:crimson">Nothing here yet...</h3>
            }
        </div>
        @await Component.InvokeAsync("CreateTask", new {vm = ViewBag.taskVM})
    </div>
</div>